package com.xcheng.scannere3;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.preference.EditTextPreference;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.SwitchPreference;
import android.text.InputType;
import android.text.method.NumberKeyListener;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.EditText;
import android.widget.Toast;

public class ScanSettingActivity extends PreferenceActivity implements
        Preference.OnPreferenceChangeListener {

    private static final String TAG = "ScanSettingActivity";
    public static final String EMPTY = "Empty";
    public static final String SPACE = "SPACE";

    public static final boolean DEFAULT_GS_MODIFY_ENABLE = false;

    public static final String DEFAULT_DATA_RECEIVE_METHOD = "BROADCAST_EVENT";

    //add by yangzhichao for t0581 20200915 start
    public static final String LEFT_SCAN_KEY = ScanUtil.LEFT_SCAN_KEY;
    public static final String RIGHT_SCAN_KEY = ScanUtil.RIGHT_SCAN_KEY;
    public static final String FRONT_SCAN_KEY = ScanUtil.FRONT_SCAN_KEY;
    //add by yangzhichao for t0581 20200915 end
    //add by yangzhichao for t0581 20200921 start
    public static final String INVERSE_CODE = "pref_inverse_code_enable";
    //add by yangzhichao for t0581 20200921 end
    public static final String SUCCESS_NOTIFICATION_KEY = "pref_success_notification";
    public static final String FAIL_NOTIFICATION_KEY = "pref_fail_notification";
    public static final String APP_NOTIFICATION_KEY = "pref_notification_enable";
    public static final String TYPING_DELAY_KEY = "pref_keyboard_typing_delay";
    public static final String USER_DEFINITION_KEY = "pref_user_definition";
    public static final String PREFIX_CHAR1_KEY = "pref_prefix_char_1";
    public static final String PREFIX_CHAR2_KEY = "pref_prefix_char_2";
    public static final String SUFFIX_CHAR1_KEY = "pref_suffix_char_1";
    public static final String SUFFIX_CHAR2_KEY = "pref_suffix_char_2";
    public static final String LETTER_CASE_KEY = "pref_letter";
    public static final String ENABLE_CHARACTER_MODIFY = "pref_character_modify_enable";
    public static final String CHARACTER_GS = "pref_character_gs";
    public static final String KEY_TIMEOUT = "pref_max_scan_time";
    public static final String DATA_RECEIVE_KEY = "pref_data_receive_method";
    public static final String SCAN_WORKMODE_KEY = "pref_scan_workmode";
    public static final String SCAN_VIEWSIZE_KEY = "pref_scan_viewsize";
    public static final String ENABLE_SETTING_LOCK = "pref_lock";
    public static final String CHANGE_PASSWORD = "pref_change_lock_password";
    public static final String ENABLE_LIGHT_AIM_KEY = "pref_light_aim_enable";
    public static final String ENABLE_LIGHT_FLASH_KEY = "pref_light_flash_enable";

    //add by yangzhichao for t0581 20200915 start
    private SwitchPreference mEnaleLeftScankey;
    private SwitchPreference mEnaleRightScankey;
    private SwitchPreference mEnaleFrontScankey;
    //add by yangzhichao for t0581 20200915 end
    //add by yangzhichao for t0581 20200915 start
    private SwitchPreference mInverseCodePreference;
    //add by yangzhichao for t0581 20200915 end
    private ListPreference mSuccessNotification;
    private ListPreference mFailNotification;
    private SwitchPreference mAppNotification;
    private ListPreference mKbdTypingDeleyPreference;
    private EditTextPreference mUserDefinitionPreference;
    private SwitchPreference mEnableCharacterModifyPreference;
    private SwitchPreference mEnableSettingLockPreference;
    private ListPreference mPrefixChar1Preference;
    private ListPreference mPrefixChar2Preference;
    private ListPreference mSuffixChar1Preference;
    private ListPreference mSuffixChar2Preference;
    private ListPreference mLetterCasePreference;
    private ListPreference mCharacterGSPreference;
    private ListPreference mTimeOutPreference;
    private ListPreference mDataReceivePreference;
    private ListPreference mScanWorkModePreference;
    private ListPreference mDecodeViewSizePreference;
    private Preference changePwdPreference;

    private SwitchPreference mLightAimEnablePreference;
    private SwitchPreference mLightFlashEnablePreference;

    private SharedPreferences mShare;
    private Editor editor;
    private Context mContext;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //change by yangzhichao for t0581 20200915 start
        initView();
        initEvent();
        initData();
        //change by yangzhichao for t0581 20200915 end

    }
    //add by yangzhichao for t0581 20200915 start
    private void initEvent() {
        changePwdPreference.setOnPreferenceClickListener(new OnPreferenceClickListener() {

            @Override
            public boolean onPreferenceClick(Preference preference) {
                // TODO Auto-generated method stub
                String password  = mShare.getString(CHANGE_PASSWORD, "0000");
                changePassword(password);
                return false;
            }
        });
    }
    private void initData() {
        mShare = ScanUtil.getSharedPreferences(ScanSettingActivity.this);
        editor = mShare.edit();
        mContext = ScanSettingActivity.this;
    }
    private void initView() {
        addPreferencesFromResource(R.xml.scan_setting);
        //add by yangzhichao for t0581 20200921 start
        mInverseCodePreference = (SwitchPreference)findPreference(INVERSE_CODE);
        //add by yangzhichao for t0581 20200921 end
        mTimeOutPreference = (ListPreference)findPreference(KEY_TIMEOUT);
        //DataReceiveMethod
        mDataReceivePreference = (ListPreference)findPreference(DATA_RECEIVE_KEY);
        //LeftScankey
        mEnaleLeftScankey = (SwitchPreference)findPreference(LEFT_SCAN_KEY);
        //RightScankey
        mEnaleRightScankey = (SwitchPreference)findPreference(RIGHT_SCAN_KEY);
        //FrontScankey
        mEnaleFrontScankey = (SwitchPreference)findPreference(FRONT_SCAN_KEY);
        mScanWorkModePreference = (ListPreference)findPreference(SCAN_WORKMODE_KEY);
        mDecodeViewSizePreference = (ListPreference)findPreference(SCAN_VIEWSIZE_KEY);

        // AIM Light enable
        mLightAimEnablePreference = (SwitchPreference)findPreference(ENABLE_LIGHT_AIM_KEY);
        // FLASH Light enable
        mLightFlashEnablePreference = (SwitchPreference)findPreference(ENABLE_LIGHT_FLASH_KEY);
        //Scan Notification
        mSuccessNotification = (ListPreference)findPreference(SUCCESS_NOTIFICATION_KEY);
        mFailNotification = (ListPreference)findPreference(FAIL_NOTIFICATION_KEY);
        //Notification
        mAppNotification = (SwitchPreference)findPreference(APP_NOTIFICATION_KEY);
        //Scan Delay Setting
        mKbdTypingDeleyPreference = (ListPreference)findPreference(TYPING_DELAY_KEY);
        mUserDefinitionPreference = (EditTextPreference)findPreference(USER_DEFINITION_KEY);
        //PrefixChar1
        mPrefixChar1Preference = (ListPreference)findPreference(PREFIX_CHAR1_KEY);
        //PrefixChar2
        mPrefixChar2Preference = (ListPreference)findPreference(PREFIX_CHAR2_KEY);
        //SuffixChar1
        mSuffixChar1Preference = (ListPreference)findPreference(SUFFIX_CHAR1_KEY);
        //SuffixChar2
        mSuffixChar2Preference = (ListPreference)findPreference(SUFFIX_CHAR2_KEY);
        //LetterCase
        mLetterCasePreference = (ListPreference)findPreference(LETTER_CASE_KEY);
        //EnableCharacterModify
        mEnableCharacterModifyPreference = (SwitchPreference)findPreference(ENABLE_CHARACTER_MODIFY);
        //CharacterGs
        mCharacterGSPreference = (ListPreference)findPreference(CHARACTER_GS);
        //EnableSettingLock
        mEnableSettingLockPreference = (SwitchPreference)findPreference(ENABLE_SETTING_LOCK);
        mEnableSettingLockPreference.setOnPreferenceChangeListener(this);
        //ChangePassword
        changePwdPreference = (Preference)findPreference(CHANGE_PASSWORD);
    }
    @Override
    protected void onResume() {
        super.onResume();
        refreshPreferences();
    }
    //add by yangzhichao for t0581 20200915 end
    //change by yangzhichao for t0581 20200915 start
    private void refreshPreferences() {
        //add by yangzhichao for t0581 20200915 start
        boolean mEnableLeftScan  = mShare.getBoolean(LEFT_SCAN_KEY,true);
        boolean mEnableRightScan  = mShare.getBoolean(RIGHT_SCAN_KEY,true);
        boolean mEnableFrontScan  = mShare.getBoolean(FRONT_SCAN_KEY,true);
        //add by yangzhichao for t0581 20200915 end
        //add by yangzhichao for t0581 20200921 start
        boolean mEnableInverseCode = mShare.getBoolean(INVERSE_CODE,false);
        mInverseCodePreference.setChecked(mEnableInverseCode);
        mInverseCodePreference.setOnPreferenceChangeListener(this);
        //add by yangzhichao for t0581 20200921 end

        boolean mEnableNotication  = mShare.getBoolean(APP_NOTIFICATION_KEY, true);
        boolean mEnableCharacterModify  = mShare.getBoolean(
                ENABLE_CHARACTER_MODIFY, DEFAULT_GS_MODIFY_ENABLE);
        boolean mEnableSettingLock = mShare.getBoolean(ENABLE_SETTING_LOCK, false);
        String mPrefixChar1  = mShare.getString(PREFIX_CHAR1_KEY,EMPTY);
        String mPrefixChar2  = mShare.getString(PREFIX_CHAR2_KEY,EMPTY);
        String mSuffixChar1  = mShare.getString(SUFFIX_CHAR1_KEY,"ENTER");
        String mSuffixChar2  = mShare.getString(SUFFIX_CHAR2_KEY,EMPTY);
        String mLetterCase  = mShare.getString(LETTER_CASE_KEY,"NONE_CASE");
        String mCharacterGS  = mShare.getString(CHARACTER_GS,EMPTY);

        String mPassword  = mShare.getString(CHANGE_PASSWORD, "0000");
        String mSuccessValue  = mShare.getString(SUCCESS_NOTIFICATION_KEY,"Sound");
        String mFailValue  = mShare.getString(FAIL_NOTIFICATION_KEY,"Mute");
        String mDataReceiveMethod = mShare.getString(DATA_RECEIVE_KEY, DEFAULT_DATA_RECEIVE_METHOD);
        String mTypingDelay  = mShare.getString(TYPING_DELAY_KEY,"0");
        String mUserDefinition = mShare.getString(USER_DEFINITION_KEY, "0");

        boolean mLightAimEnable = mShare.getBoolean(ENABLE_LIGHT_AIM_KEY, true);
        boolean mLightFlashEnable = mShare.getBoolean(ENABLE_LIGHT_FLASH_KEY, true);

        //Max scan time
        String maxScanTime = mShare.getString(KEY_TIMEOUT, "2000");
        E3Util.setTimeout(Integer.parseInt(maxScanTime));

        mTimeOutPreference.setValue(maxScanTime);
        mTimeOutPreference.setOnPreferenceChangeListener(this);
        updateTimeoutPreferenceSummary(Integer.parseInt(maxScanTime));

        mDataReceivePreference.setValue(mDataReceiveMethod);
        mDataReceivePreference.setSummary(mDataReceiveMethod);
        mDataReceivePreference.setOnPreferenceChangeListener(this);

        //add by yangzhichao for t0581 20200915 start
        mEnaleLeftScankey.setChecked(mEnableLeftScan);
        mEnaleLeftScankey.setOnPreferenceChangeListener(this);

        mEnaleRightScankey.setChecked(mEnableRightScan);
        mEnaleRightScankey.setOnPreferenceChangeListener(this);

        mEnaleFrontScankey.setChecked(mEnableFrontScan);
        mEnaleFrontScankey.setOnPreferenceChangeListener(this);
        //add by yangzhichao for t0581 20200915 end

        //ScanWorkMode
        String curWorkMode = mShare.getString(SCAN_WORKMODE_KEY, "0");
        E3Util.setScanMode(Integer.parseInt(curWorkMode));

        mScanWorkModePreference.setValue(curWorkMode);
        mScanWorkModePreference.setOnPreferenceChangeListener(this);
        updateWorkModePreferenceSummary(Integer.parseInt(curWorkMode));

        //Decode Viewsize
        String curViewsize = mShare.getString(SCAN_VIEWSIZE_KEY, "0");
        E3Util.configViewSize(Integer.parseInt(curViewsize));

        mDecodeViewSizePreference.setValue(curViewsize);
        mDecodeViewSizePreference.setOnPreferenceChangeListener(this);
        updateDecodeViewSizePreferenceSummary(Integer.parseInt(curViewsize));

        mLightAimEnablePreference.setChecked(mLightAimEnable);
        mLightAimEnablePreference.setOnPreferenceChangeListener(this);

        mLightFlashEnablePreference.setChecked(mLightFlashEnable);
        mLightFlashEnablePreference.setOnPreferenceChangeListener(this);

        mSuccessNotification.setValue(mSuccessValue);
        mSuccessNotification.setSummary(mSuccessValue);
        mSuccessNotification.setOnPreferenceChangeListener(this);

        mFailNotification.setValue(mFailValue);
        mFailNotification.setSummary(mFailValue);
        mFailNotification.setOnPreferenceChangeListener(this);

        mAppNotification.setChecked(mEnableNotication);
        mAppNotification.setOnPreferenceChangeListener(this);


        mKbdTypingDeleyPreference.setValue(mTypingDelay);
        mKbdTypingDeleyPreference.setSummary(mKbdTypingDeleyPreference.getEntry());
        mKbdTypingDeleyPreference.setEnabled("KEYBOARD_EVENT".equals(mDataReceiveMethod));
        mKbdTypingDeleyPreference.setOnPreferenceChangeListener(this);

        mUserDefinitionPreference.setText(mUserDefinition);
        mUserDefinitionPreference.setSummary(mUserDefinition + " MilliSecond");
        mUserDefinitionPreference.setEnabled("1".equals(mTypingDelay)
                && "KEYBOARD_EVENT".equals(mDataReceiveMethod));
        mUserDefinitionPreference.setOnPreferenceChangeListener(this);

        mPrefixChar1Preference.setValue(mPrefixChar1);
        mPrefixChar1Preference.setSummary("%".equals(mPrefixChar1)?"%%":mPrefixChar1);
        mPrefixChar1Preference.setOnPreferenceChangeListener(this);

        mPrefixChar2Preference.setValue(mPrefixChar2);
        mPrefixChar2Preference.setSummary("%".equals(mPrefixChar2)?"%%":mPrefixChar2);
        mPrefixChar2Preference.setOnPreferenceChangeListener(this);

        mSuffixChar1Preference.setValue(mSuffixChar1);
        mSuffixChar1Preference.setSummary("%".equals(mSuffixChar1)?"%%":mSuffixChar1);
        mSuffixChar1Preference.setOnPreferenceChangeListener(this);

        mSuffixChar2Preference.setValue(mSuffixChar2);
        mSuffixChar2Preference.setSummary("%".equals(mSuffixChar2)?"%%":mSuffixChar2);
        mSuffixChar2Preference.setOnPreferenceChangeListener(this);

        mLetterCasePreference.setValue(mLetterCase);
        mLetterCasePreference.setSummary(mLetterCase);
        mLetterCasePreference.setOnPreferenceChangeListener(this);

        mEnableCharacterModifyPreference.setChecked(mEnableCharacterModify);
        mEnableCharacterModifyPreference.setOnPreferenceChangeListener(this);

        mCharacterGSPreference.setValue(mCharacterGS);
        mCharacterGSPreference.setSummary("%".equals(mCharacterGS)?"%%":mCharacterGS);
        mCharacterGSPreference.setEnabled(mEnableCharacterModify);
        mCharacterGSPreference.setOnPreferenceChangeListener(this);

        mEnableSettingLockPreference.setChecked(mEnableSettingLock);

    }
    //change by yangzhichao for t0581 20200915 end
    @Override
    public boolean onPreferenceChange(Preference preference, Object newValue) {
        // TODO Auto-generated method stub
        Log.d(TAG, "onPreferenceChange: preference = " + preference);
        Log.d(TAG, "onPreferenceChange: newValue = " + newValue);

        //add by yangzhichao for t0581 20200915 start
        if (preference == mEnaleLeftScankey) {
            if (mEnaleLeftScankey.isChecked() != (Boolean) newValue) {
                boolean value = (Boolean) (newValue);
                mEnaleLeftScankey.setChecked(value);
                editor.putBoolean(LEFT_SCAN_KEY,value);
            }
        }
        //add by yangzhichao for t0581 20200921 start
        else if (preference == mInverseCodePreference) {
            if (mInverseCodePreference.isChecked() != (Boolean) newValue) {
                boolean value = (Boolean) (newValue);
                mInverseCodePreference.setChecked(value);
                editor.putBoolean(INVERSE_CODE,value);
                ScanUtil.setAllInverseCodeEnable(mContext,value);
            }
        }
        //add by yangzhichao for t0581 20200921 end
        else if (preference == mEnaleRightScankey) {
            if (mEnaleRightScankey.isChecked() != (Boolean) newValue) {
                boolean value = (Boolean) (newValue);
                mEnaleRightScankey.setChecked(value);
                editor.putBoolean(RIGHT_SCAN_KEY,value);
            }
        } else if (preference == mEnaleFrontScankey) {
            if (mEnaleFrontScankey.isChecked() != (Boolean) newValue) {
                boolean value = (Boolean) (newValue);
                mEnaleFrontScankey.setChecked(value);
                editor.putBoolean(FRONT_SCAN_KEY,value);
            }
        } else if (preference == mSuccessNotification) {
        //add by yangzhichao for t0581 20200915 end
            String value = (String) (newValue);
            mSuccessNotification.setValue(value);
            mSuccessNotification.setSummary(value);
            editor.putString(SUCCESS_NOTIFICATION_KEY,value);
        } else if (preference == mFailNotification) {
            String value = (String) (newValue);
            mFailNotification.setValue(value);
            mFailNotification.setSummary(value);
            editor.putString(FAIL_NOTIFICATION_KEY,value);
        } else if (preference == mAppNotification) {
            if (mAppNotification.isChecked() != (Boolean) newValue) {
                boolean value = (Boolean) (newValue);
                mAppNotification.setChecked(value);
                editor.putBoolean(APP_NOTIFICATION_KEY,value);
            }
        } else if (preference == mKbdTypingDeleyPreference) {
            String value = (String) (newValue);
            mKbdTypingDeleyPreference.setValue(value);
            mKbdTypingDeleyPreference.setSummary(mKbdTypingDeleyPreference.getEntry());
            mUserDefinitionPreference.setEnabled("1".equals(value));
            editor.putString(TYPING_DELAY_KEY,value);
        } else if (preference == mUserDefinitionPreference) {
            String value = (String) (newValue);
            mUserDefinitionPreference.setText(value);
            mUserDefinitionPreference.setSummary(value + " MilliSecond");
            editor.putString(USER_DEFINITION_KEY, value);
        } else if (preference == mPrefixChar1Preference) {
            String value = (String) (newValue);
            mPrefixChar1Preference.setValue(value);
            mPrefixChar1Preference.setSummary("%".equals(value)?"%%":value);
            editor.putString(PREFIX_CHAR1_KEY,value);
        } else if (preference == mPrefixChar2Preference) {
            String value = (String) (newValue);
            mPrefixChar2Preference.setValue(value);
            mPrefixChar2Preference.setSummary("%".equals(value)?"%%":value);
            editor.putString(PREFIX_CHAR2_KEY,value);
        } else if (preference == mSuffixChar1Preference) {
            String value = (String) (newValue);
            mSuffixChar1Preference.setValue(value);
            mSuffixChar1Preference.setSummary("%".equals(value)?"%%":value);
            editor.putString(SUFFIX_CHAR1_KEY,value);
        } else if (preference == mSuffixChar2Preference) {
            String value = (String) (newValue);
            mSuffixChar2Preference.setValue(value);
            mSuffixChar2Preference.setSummary("%".equals(value)?"%%":value);
            editor.putString(SUFFIX_CHAR2_KEY,value);
        } else if (preference == mLetterCasePreference) {
            String value = (String) (newValue);
            mLetterCasePreference.setValue(value);
            mLetterCasePreference.setSummary(value);
            editor.putString(LETTER_CASE_KEY,value);
        } else if (preference == mEnableCharacterModifyPreference) {
            if (mEnableCharacterModifyPreference.isChecked() != (Boolean) newValue) {
                boolean value = (Boolean) (newValue);
                mEnableCharacterModifyPreference.setChecked(value);
                editor.putBoolean(ENABLE_CHARACTER_MODIFY,value);
                mCharacterGSPreference.setEnabled(value);
            }
        } else if (preference == mCharacterGSPreference) {
            String value = (String) (newValue);
            mCharacterGSPreference.setValue(value);
            mCharacterGSPreference.setSummary("%".equals(value)?"%%":value);
            editor.putString(CHARACTER_GS,value);
        } else if (preference == mTimeOutPreference) {
            String value = (String) (newValue);
            int scanTime = Integer.parseInt(value);
            mTimeOutPreference.setValue(value);
            updateTimeoutPreferenceSummary(scanTime);
            editor.putString(KEY_TIMEOUT,value);
            E3Util.setTimeout(scanTime);
        } else if (preference == mDataReceivePreference) {
            String value = (String) (newValue);
            mDataReceivePreference.setValue(value);
            mDataReceivePreference.setSummary(value);
            mKbdTypingDeleyPreference.setEnabled("KEYBOARD_EVENT".equals(value));
            mUserDefinitionPreference.setEnabled("KEYBOARD_EVENT".equals(value)
                    && "1".equals(mKbdTypingDeleyPreference.getValue()));
            editor.putString(DATA_RECEIVE_KEY,value);
        } else if (preference == mScanWorkModePreference) {
            String value = (String) (newValue);
            int workmode = Integer.parseInt(value);
            mScanWorkModePreference.setValue(value);
            updateWorkModePreferenceSummary(workmode);
            editor.putString(SCAN_WORKMODE_KEY,value);
            E3Util.setScanMode(workmode);
        } else if (preference == mDecodeViewSizePreference) {
            String value = (String) (newValue);
            int viewsize = Integer.parseInt(value);
            mDecodeViewSizePreference.setValue(value);
            updateDecodeViewSizePreferenceSummary(viewsize);
            editor.putString(SCAN_VIEWSIZE_KEY, value);
            E3Util.configViewSize(viewsize);
        } else if (preference == mLightAimEnablePreference) {
            boolean value = (Boolean) (newValue);
            mLightAimEnablePreference.setChecked(value);
            editor.putBoolean(ENABLE_LIGHT_AIM_KEY, value);
            E3Util.setLightAimSupport(value);
        } else if (preference == mLightFlashEnablePreference) {
            boolean value = (Boolean) (newValue);
            mLightFlashEnablePreference.setChecked(value);
            editor.putBoolean(ENABLE_LIGHT_FLASH_KEY, value);
            E3Util.setLightFlashSupport(value);
        } else if (preference == mEnableSettingLockPreference) {
            boolean value = (Boolean) (newValue);
            String password  = mShare.getString(CHANGE_PASSWORD, "0000");
            checkPassword(password,value);
        }
        editor.commit();
        return false;
    }

    private void updateTimeoutPreferenceSummary(long currentTimeout) {
        String summary;
        if (currentTimeout < 0) {
            // Unsupported value
            summary = "";
        } else {
            final CharSequence[] entries = mTimeOutPreference.getEntries();
            final CharSequence[] values = mTimeOutPreference.getEntryValues();
            if (entries == null || entries.length == 0) {
                summary = "";
            } else {
                int best = 0;
                for (int i = 0; i < values.length; i++) {
                    long timeout = Long.parseLong(values[i].toString());
                    if (currentTimeout >= timeout) {
                        best = i;
                    }
                }
                summary = entries[best].toString();
            }
        }
        mTimeOutPreference.setSummary(summary);
    }

    private void updateWorkModePreferenceSummary(int newWorkmode) {
        String summary;
        if (newWorkmode < 0) {
            // Unsupported value
            summary = "";
        } else {
            final CharSequence[] entries = mScanWorkModePreference.getEntries();
            final CharSequence[] values = mScanWorkModePreference.getEntryValues();
            if (entries == null || entries.length == 0) {
                summary = "";
            } else {
                int best = 0;
                for (int i = 0; i < values.length; i++) {
                    int workmode = Integer.parseInt(values[i].toString());
                    if (newWorkmode >= workmode) {
                        best = i;
                    }
                }
                summary = entries[best].toString();
            }
        }
        mScanWorkModePreference.setSummary(summary);
    }

    private void updateDecodeViewSizePreferenceSummary(int newViewSize) {
        String summary;
        if (newViewSize < 0) {
            // Unsupported value
            summary = "";
        } else {
            final CharSequence[] entries = mDecodeViewSizePreference.getEntries();
            final CharSequence[] values = mDecodeViewSizePreference.getEntryValues();
            if (entries == null || entries.length == 0) {
                summary = "";
            } else {
                int best = 0;
                for (int i = 0; i < values.length; i++) {
                    int viewsize = Integer.parseInt(values[i].toString());
                    if (newViewSize >= viewsize) {
                        best = i;
                    }
                }
                summary = entries[best].toString();
            }
        }
        mDecodeViewSizePreference.setSummary(summary);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_FUNCTION
                || keyCode == KeyEvent.KEYCODE_F11) {
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_FUNCTION
                || keyCode == KeyEvent.KEYCODE_F11) {
            return true;
        }
        return super.onKeyUp(keyCode, event);
    }

    private void checkPassword(final String password, final boolean newValue){
        final EditText et = new EditText(mContext);
        new AlertDialog.Builder(mContext).setTitle(R.string.check_password)
        .setView(et)
        .setPositiveButton(R.string.change_password_ok, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    String input = et.getText().toString();
                    if (input.equals(password)) {
                        mEnableSettingLockPreference.setChecked(newValue);
                        editor.putBoolean(ENABLE_SETTING_LOCK,newValue);
                        editor.commit();
                    }else {
                        Toast.makeText(mContext, R.string.wrong_password_tips, Toast.LENGTH_SHORT).show();
                    }
                }
        })
        .setNegativeButton(R.string.change_password_cancel, null)
        .show();
    }

    private void changePassword(final String password){
        final EditText et = new EditText(mContext);
        new AlertDialog.Builder(mContext).setTitle(R.string.current_password)
        .setView(et)
        .setPositiveButton(R.string.change_password_ok, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    String input = et.getText().toString();
                    if (input.equals(password)) {
                        newPassword();
                    }else {
                        Toast.makeText(mContext, R.string.wrong_password_tips, Toast.LENGTH_SHORT).show();
                    }
                }
        })
        .setNegativeButton(R.string.change_password_cancel, null)
        .show();
    }

    private void newPassword(){
        final EditText et = new EditText(mContext);
        et.setKeyListener(new NumberKeyListener(){

            protected char[] getAcceptedChars(){
                char[] numberChars ={'1','2','3','4','5','6','7','8','9','0','a','b','c',
                            'd','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s',
                            't','u','v','w','x','y','z','A','B','C','D','E','F','G','H','I',
                            'J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
                return numberChars;
            }

            @Override
            public int getInputType() {
                // TODO Auto-generated method stub
                return InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PASSWORD;
            }
        });
        et.setHint(R.string.new_password_tips);
        new AlertDialog.Builder(mContext).setTitle(R.string.new_password)
        .setView(et)
        .setPositiveButton(R.string.change_password_ok, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    String input = et.getText().toString();
                    editor.putString(CHANGE_PASSWORD, input);
                    editor.commit();
                }
        })
        .setNegativeButton(R.string.change_password_cancel, null)
        .show();
    }
}
