package com.xcheng.scannere3.codesetting;

import android.os.Bundle;
import android.content.Context;
import android.content.SharedPreferences.Editor;
import android.preference.ListPreference;
import android.preference.SwitchPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.util.Log;
import android.text.TextUtils;
import com.xcheng.scannere3.R;

//add by yangzhichao for t0581 20201016 start
import com.xcheng.scannere3.XCScanner;
//add by yangzhichao for t0581 20201016 end

public class CodeBarSetting extends BaseSetting {

    private static final String TAG = "CodeBarSetting";

    //modify by yangzhichao for t0581 20201016 start
    //private static final int CLSI_EDIT_PARM = 54;
    //private static final int NOTIS_EDIT_PARM = 55;
    private static final int TRANSMIT_CHECK_DIGIT_PARM = XCScanner.TAG_CODABAR_CHECK_DIGIT_MODE;
    private static final int VALUE_TRANSMIT_CHECK_DIGIT_OFF = 0;
    private static final int VALUE_TRANSMIT_CHECK_DIGIT_ON = 2;
    
    private static final int MAX_PARM = XCScanner.TAG_CODABAR_MAX_LENGTH;
    private static final int MIN_PARM = XCScanner.TAG_CODABAR_MIN_LENGTH;

    //private static final String KEY_CLSI_EDIT = "codebar_clsi_edit";
    //private static final String KEY_NOTIS_EDIT = "codebar_notis_edit";
    private static final String KEY_TRANSMIT_CHECK_DIGIT = "transmit_check_digit";
    //modify by yangzhichao for t0581 20201016 end
    private static final String KEY_MIN = "codebar_min";
    private static final String KEY_MAX = "codebar_max";

    private static final int MAX_LENGTH = 127;
    private static final int MIN_LENGTH = 4;
    private static final int DFAULT_MIN_LENGTH = 5;

    //modify by yangzhichao for t0581 20201016 start
    //private SwitchPreference mClsiEditPref;
    //private SwitchPreference mNotisEditPref;
    private SwitchPreference mTransmitCheckDigitPref;
    //modify by yangzhichao for t0581 20201016 end

    private Preference mMaxPref;
    private Preference mMinPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //modify by yangzhichao for t0581 20201016 start
        /*
        mClsiEditPref = (SwitchPreference) createPreference(this, TYPE_SWTICH,
                KEY_CLSI_EDIT, getString(R.string.text_clsi_edit), CLSI_EDIT_PARM);
        mClsiEditPref.setChecked(BaseSetting.getSharedPreferences(this).getInt(KEY_CLSI_EDIT, -1) == 1);
        mClsiEditPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                boolean checked = (Boolean) objValue;
                Editor editor = BaseSetting.getSharedPreferences(CodeBarSetting.this).edit();
                editor.putInt(KEY_CLSI_EDIT, checked ? 1 : 0);
                editor.commit();
                setParameter(CLSI_EDIT_PARM, checked ? 1 : 0);
                return true;
            }
        });

        mNotisEditPref = (SwitchPreference) createPreference(this, TYPE_SWTICH,
                KEY_NOTIS_EDIT, getString(R.string.text_notis_edit), NOTIS_EDIT_PARM);
        mNotisEditPref.setChecked(BaseSetting.getSharedPreferences(this).getInt(KEY_NOTIS_EDIT, -1) == 1);
        mNotisEditPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                boolean checked = (Boolean) objValue;
                Editor editor = BaseSetting.getSharedPreferences(CodeBarSetting.this).edit();
                editor.putInt(KEY_NOTIS_EDIT, checked ? 1 : 0);
                editor.commit();
                setParameter(NOTIS_EDIT_PARM, checked ? 1 : 0);
                return true;
            }
        });
        */

        mTransmitCheckDigitPref = (SwitchPreference) createPreference(this, TYPE_SWTICH,
                KEY_TRANSMIT_CHECK_DIGIT, getString(R.string.transmit_check_digit), TRANSMIT_CHECK_DIGIT_PARM);
        //mTransmitCheckDigitPref.setChecked(BaseSetting.getSharedPreferences(this).getInt(KEY_TRANSMIT_CHECK_DIGIT, -1) == 1);
        mTransmitCheckDigitPref.setChecked(getDecoderTagValue(TRANSMIT_CHECK_DIGIT_PARM) != VALUE_TRANSMIT_CHECK_DIGIT_OFF);
        mTransmitCheckDigitPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                boolean checked = (Boolean) objValue;
                Editor editor = BaseSetting.getSharedPreferences(CodeBarSetting.this).edit();
                editor.putInt(KEY_TRANSMIT_CHECK_DIGIT, checked ? 1 : 0);
                editor.commit();
                setParameter(TRANSMIT_CHECK_DIGIT_PARM, checked ? VALUE_TRANSMIT_CHECK_DIGIT_ON : VALUE_TRANSMIT_CHECK_DIGIT_OFF);
                return true;
            }
        });

        final String maxTitle = getString(R.string.setting_max_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMaxPref = createPreference(this, TYPE_PREFERENCE, KEY_MAX, maxTitle, MAX_PARM);
        //int maxValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MAX, -1);
        int maxValue = getDecoderTagValue(MAX_PARM);
        if (maxValue != -1){
            mMaxPref.setSummary(Integer.toString(maxValue));
        } else {
            mMaxPref.setSummary(String.valueOf(MAX_LENGTH));
        }
        mMaxPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MAX);
                createMaxLengthDialog(CodeBarSetting.this, preference, maxTitle,
                        MAX_LENGTH, MIN_LENGTH, MAX_PARM);
                return true;
            }
        });

        final String minTitle = getString(R.string.setting_min_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMinPref = createPreference(this, TYPE_PREFERENCE, KEY_MIN, minTitle, MIN_PARM);
        //int minValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MIN, -1);
        int minValue = getDecoderTagValue(MIN_PARM);
        if (minValue != -1){
            mMinPref.setSummary(Integer.toString(minValue));
        } else {
            mMinPref.setSummary(String.valueOf(DFAULT_MIN_LENGTH));
        }
        mMinPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MIN);
                createMinLengthDialog(CodeBarSetting.this, preference, minTitle,
                        MAX_LENGTH, MIN_LENGTH, MIN_PARM);
                return true;
            }
        });
        //modify by yangzhichao for t0581 20201016 end
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
