package com.xcheng.scannere3.codesetting;

import android.os.Bundle;
import android.content.Context;
import android.content.SharedPreferences.Editor;
import android.preference.ListPreference;
import android.preference.SwitchPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.util.Log;
import android.text.TextUtils;
import com.xcheng.scannere3.R;
import com.xcheng.scannere3.E3Util;

//add by yangzhichao for t0581 20201017 start
import com.xcheng.scannere3.XCScanner;
//add by yangzhichao for t0581 20201017 end

public class HanXinSetting extends BaseSetting {

    private static final String TAG = "HanXinSetting";

    //modify by yangzhichao for t0581 20201017 start
    //private static final int INVERSE_PARM = 1168;
    private static final int MAX_PARM = XCScanner.TAG_HANXIN_MAX_LENGTH;
    private static final int MIN_PARM = XCScanner.TAG_HANXIN_MIN_LENGTH;

    //private static final String KEY_INVERSE = "hanxin_inverce";
    private static final String KEY_MIN = "hanxin_min";
    private static final String KEY_MAX = "hanxin_max";
    private static final int MAX_LENGTH = 7827;
    private static final int MIN_LENGTH = 1;
    private static final int DFAULT_MIN_LENGTH = 4;
    private Preference mMaxPref;
    private Preference mMinPref;
    //private ListPreference mInversePref;
    //modify by yangzhichao for t0581 20201017 end

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //modify by yangzhichao for t0581 20201017 start
        final String maxTitle = getString(R.string.setting_max_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMaxPref = createPreference(this, TYPE_PREFERENCE, KEY_MAX, maxTitle, MAX_PARM);
        //int maxValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MAX, -1);
        int maxValue = getDecoderTagValue(MAX_PARM);
        if (maxValue != -1){
            mMaxPref.setSummary(Integer.toString(maxValue));
        } else {
            mMaxPref.setSummary(String.valueOf(MAX_LENGTH));
        }
        mMaxPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MAX);
                createMaxLengthDialog(HanXinSetting.this, preference, maxTitle,
                        MAX_LENGTH, MIN_LENGTH, MAX_PARM);
                return true;
            }
        });

        final String minTitle = getString(R.string.setting_min_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMinPref = createPreference(this, TYPE_PREFERENCE, KEY_MIN, minTitle, MIN_PARM);
        //int minValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MIN, -1);
        int minValue = getDecoderTagValue(MIN_PARM);
        if (minValue != -1){
            mMinPref.setSummary(Integer.toString(minValue));
        } else {
            mMinPref.setSummary(String.valueOf(DFAULT_MIN_LENGTH));
        }
        mMinPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MIN);
                createMinLengthDialog(HanXinSetting.this, preference, minTitle,
                        MAX_LENGTH, MIN_LENGTH, MIN_PARM);
                return true;
            }
        });
        /*
        mInversePref = (ListPreference) createPreference(this, TYPE_LIST,
                KEY_INVERSE, getString(R.string.inverse_decoder_setting), INVERSE_PARM);
        mInversePref.setEntries(R.array.inverse_decoder_entries);
        mInversePref.setEntryValues(R.array.inverse_decoder_values);
        mInversePref.setDialogTitle(R.string.inverse_decoder_setting);
        int value = BaseSetting.getSharedPreferences(this).getInt(KEY_INVERSE, -1);
        if (value != -1){
            mInversePref.setValueIndex(value);
            updateListPreferenceSummary(mInversePref, value);
        }
        mInversePref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                Editor editor = BaseSetting.getSharedPreferences(HanXinSetting.this).edit();
                editor.putInt(KEY_INVERSE, new Integer((String) objValue));
                editor.commit();
                setParameter(INVERSE_PARM, new Integer((String) objValue));
                updateListPreferenceSummary((ListPreference)preference,
                        Long.parseLong((String) objValue));
                return true;
            }
        });
        */
        //modify by yangzhichao for t0581 20201017 end
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
