package com.xcheng.scannere3.codesetting;

import android.os.Bundle;
import android.content.Context;
import android.content.SharedPreferences.Editor;
import android.preference.ListPreference;
import android.preference.SwitchPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.util.Log;
import android.text.TextUtils;
import com.xcheng.scannere3.R;

public class Industrial2of5Setting extends BaseSetting {

    private static final String TAG = "Industrial2of5Setting";

    private static final int MIN_LENGTH_PARM = 20;
    private static final int MAX_LENGTH_PARM = 21;

    private static final String KEY_MIN = "industrial2of5_min";
    private static final String KEY_MAX = "industrial2of5_max";

    private static final int MAX_LENGTH = 55;
    private static final int MIN_LENGTH = 0;
    private static final int DFAULT_MIN_LENGTH = 12;

    private Preference mMaxPref;
    private Preference mMinPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        final String maxTitle = getString(R.string.setting_max_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMaxPref = createPreference(this, TYPE_PREFERENCE, KEY_MAX, maxTitle, MAX_LENGTH_PARM);
        //modify by yangzhichao for t0581 20201017 start
        //int maxValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MAX, -1);
        int maxValue = getDecoderTagValue(MAX_LENGTH_PARM);
        //modify by yangzhichao for t0581 20201017 end
        if (maxValue != -1){
            mMaxPref.setSummary(Integer.toString(maxValue));
        } else {
            mMaxPref.setSummary(String.valueOf(MAX_LENGTH));
        }
        mMaxPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MAX);
                createMaxLengthDialog(Industrial2of5Setting.this, preference, maxTitle,
                        MAX_LENGTH, MIN_LENGTH, MAX_LENGTH_PARM);
                return true;
            }
        });

        final String minTitle = getString(R.string.setting_min_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMinPref = createPreference(this, TYPE_PREFERENCE, KEY_MIN, minTitle, MIN_LENGTH_PARM);
        //modify by yangzhichao for t0581 20201017 start
        //int minValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MIN, -1);
        int minValue = getDecoderTagValue(MIN_LENGTH_PARM);
        //modify by yangzhichao for t0581 20201017 end
        if (minValue != -1){
            mMinPref.setSummary(Integer.toString(minValue));
        } else {
            mMinPref.setSummary(String.valueOf(MIN_LENGTH));
        }
        mMinPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MIN);
                createMinLengthDialog(Industrial2of5Setting.this, preference, minTitle,
                        MAX_LENGTH, MIN_LENGTH, MIN_LENGTH_PARM);
                return true;
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
